/***

Copyright 2011-2012 Carlos Moreno Muoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");	
	
	cambio=0; //Contador que controla el cambio de fotograma
	fotograma=0; //Nmero de fotograma a dibujars
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //botn de depurar

	//Aadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	
	//Inicializamos el jugador
	jugador=new Jugador(23);
	//Inicializamos el escenario
	escenario=new Escenario(1);
	
	posX=Math.round(escenario.xini);
	posY=Math.round(escenario.yini);
	ruta=new Ruta(jugador.getX(),jugador.getY(),jugador.getX(),jugador.getY(),0,0);
	
	objeto_destacado=-1;
	
	
	//Bocadillos (los consideramos como parte del escenario)
	bocadillos=new Array(1);
	bocadillos[0]=new Bocadillo("contestador",44,8,60,50);
	
	cerrar_destacado=-1;
        contexto.lineWidth = 2; //Grosor
        
        menu=new Menu(10,10);
	setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
}

function run(){
	animar();
	dibujar();
}

function animar(){
	
	//A partir del area en la que nos encontramos, nos movemos en funcin de sus lmites
	if(jugador.getX()>ruta.getX())
		posX-=MAX_VELOCIDAD;
	else if(jugador.getX()<ruta.getX())
		posX+=MAX_VELOCIDAD;
			
	if(jugador.getY()>ruta.getY())
		posY-=MAX_VELOCIDAD;
	else if(jugador.getY()<ruta.getY())
		posY+=MAX_VELOCIDAD;		
		
	//Calculamos el fotograma
	if(jugador.getX()!=ruta.getX() || jugador.getY()!=ruta.getY()){ //Se est moviendo
		if(cambio<=0){
			fotograma=(fotograma+1)%(jugador.cuerpo_img.length);
			cambio=MAX_CAMBIO_FOTOGRAMA;
		}else{
			cambio-=INTERVALO_REFRESCAR_PANTALLA;
		}		
	}else{
		if(ruta.finalizada()){
			cambio=0;
			fotograma=0;
		}
	}
}

function dibujar() {

        dibujar_fondo();
        
	//Controlamos si el jugador est pasando por delante o por detrs de un objeto
	if(jugador_detras_objeto()){
		dibujar_rastro(); //dibujamos, si procede, el rastro del personaje
		dibujar_jugador(); //pintamos el jugador
		dibujar_objetos(); //dibujamos los objetos con los que interactuaremos en el escenario
	}else{
		dibujar_objetos(); //dibujamos los objetos con los que interactuaremos en el escenario
		dibujar_rastro(); //dibujamos, si procede, el rastro del personaje
		dibujar_jugador(); //pintamos el jugador
	}
	
	dibujar_bocadillos(); //Dibujamos los bocadillos activos
	
	//Depuramos si hemos activado el modo depurar
	if(depurar){
		dibujar_depurar();
	}
        
        dibujar_menu();
}

function raton_liberado(evento) {
    
        //Adaptamos las coordenadas del evento
        var x_evento=adaptar_x_evento(evento);
        var y_evento=adaptar_y_evento(evento);

	if(cerrar_destacado!=-1){ //Estamos interactuando con un botn
                bocadillos[cerrar_destacado].estado=2;
		cerrar_destacado=-1;
	}else if(objeto_destacado!=-1){ //Estamos interactuando con un objeto
		if(escenario.objetos[objeto_destacado].id=="telefono"){
			lanzar_bocadillo_contestador();
		}else{
			imprime_mensaje("Has clickeado el objeto \""+escenario.objetos[objeto_destacado].id+"\": ahora mismo no hace nada");
		}
	}else{ //Estamos moviendonos
		//Controlamos que no se nos salga de los mrgenes
		var n_areas=escenario.area.length;
		var area_destino; //Area al que queremos ir
		area_actual=calcular_area(jugador.getX()); //Area en el que estamos
		var xdest;
		var ydest;
                        
                area_destino=calcular_area(x_evento);

                if(area_destino==0 && x_evento<escenario.area[0][0])
                        xdest=escenario.area[0][0];
                else if(area_destino==n_areas-1)
                        xdest=escenario.area[n_areas-1][0];
                else
                        xdest=x_evento;

                if(y_evento>escenario.area[area_destino][1])
                        ydest=y_evento;
                else
                        ydest=escenario.area[area_destino][1];
				
		//Creamos una nueva ruta
		ruta = new Ruta(jugador.getX(),jugador.getY(),xdest,ydest,area_actual,area_destino);
	}
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_area.style.visibility="visible";
		document.formulario.texto_xpos.style.visibility="visible";
		document.formulario.texto_ypos.style.visibility="visible";
		document.formulario.texto_xdest.style.visibility="visible";
		document.formulario.texto_ydest.style.visibility="visible";
		//document.canvas.style.border="1px solid #c3c3c3"
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_area.style.visibility="hidden";
		document.formulario.texto_xpos.style.visibility="hidden";
		document.formulario.texto_ypos.style.visibility="hidden";
		document.formulario.texto_xdest.style.visibility="hidden";
		document.formulario.texto_ydest.style.visibility="hidden";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function posicion_relativa(x0,y0,x1,y1,x2,y2){
	
	var d=(y2-y1)*x0+(x1-x2)*y0+(x2*y1-y2*x1);
	
	return d<=0;
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function calcular_area(x){
	var a=escenario.area.length-1; //Area en el que estamos
	
	while(a>0 && x<escenario.area[a][0])
		a--;
		
	return a;
}

function raton_movido(evento){
    
    //Adaptamos las coordenadas del evento
    var x_evento=adaptar_x_evento(evento);
    var y_evento=adaptar_y_evento(evento);
    
    if(y_evento<0){
        //Replegamos el menu
        if(menu.estado==DESPLEGAR_MENU) menu.estado=REPLEGAR_MENU;        
    }else if(y_evento>100){
        //Comprobamos si estamos pasando por encima de un botn
        destacar_botones(x_evento,y_evento);
        //Replegamos el menu
        if(menu.estado==DESPLEGAR_MENU) menu.estado=REPLEGAR_MENU;
    }else{
        //Desplegaos el men
        menu.estado=DESPLEGAR_MENU;
    }
    //Comprobamos si estamos pasando por encima de un objeto
    if(cerrar_destacado==-1)
            destacar_objeto(x_evento,y_evento);
}

function destacar_objeto(x,y){
	var i;
	objeto_destacado=-1;
	for(i=0;i<escenario.objetos.length && objeto_destacado==-1;i++){
		var x1=escenario.objetos[i].x;
		var y1=escenario.objetos[i].y;
		var x2=escenario.objetos[i].x+escenario.objetos[i].width;
		var y2=escenario.objetos[i].y+escenario.objetos[i].height;
		
		if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
			objeto_destacado=i;
	}
}

function lanzar_bocadillo_contestador(){
	bocadillos[0].t="HOLA";
	bocadillos[0].estado=1;
}

function destacar_botones(x,y){
	cerrar_destacado=-1;
        var i;
        for(i=0;i<bocadillos.length && cerrar_destacado==-1;i++){
            var x1=bocadillos[i].cerrar_x;
            var y1=bocadillos[i].cerrar_y;
            var x2=bocadillos[i].cerrar_x+bocadillos[i].cerrar_width;
            var y2=bocadillos[i].cerrar_y+bocadillos[i].cerrar_height;

            if(x>=x1 && x<=x2 && y>=y1 && y<=y2)
                    cerrar_destacado=i;
         }
}

function jugador_detras_objeto(){
	var i;
	for(i=0;i<escenario.objetos.length && objeto_destacado==-1;i++){
		var x1=escenario.objetos[i].x;
		var y1=escenario.objetos[i].y;
		var x2=escenario.objetos[i].x+escenario.objetos[i].width;
		var y2=escenario.objetos[i].y+escenario.objetos[i].height;
		
		if(jugador.getY()<y2)
			return true;
	}
	return false;
}

function adaptar_x_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerX;//-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetX;//-ANCHURA_NAVEGADOR/2+ANCHURA_VENTANA/2;        
    }
    
    else return -1; //Error    
}

function adaptar_y_evento(evento){
    
    if (evento.layerX || evento.layerX == 0) { // Mozilla
        return evento.layerY;
    } else if (evento.offsetX || evento.offsetX == 0) { // Opera
        return evento.offsetY;        
    }
    
    else return -1; //Error    
}